support for multiple slice reference images
[sliceimage.git] / build.sh
index 4f9b8e3..c5cfcb7 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -37,35 +37,34 @@ pl_process_fedora_options $@
 shiftcount=$?
 shift $shiftcount
 
-# pldistro expected as $1 - defaults to planetlab
-pldistro=planetlab
-[ -n "$@" ] && pldistro=$1
+# pldistro expected as $1 
+pldistro=$1 ; shift
+# The vserver reference name - this comes from spec's slicefamily
+vrefname=$1; shift
 
 # Do not tolerate errors
 set -e
 
 # Path's to the vserver references images and stubs
 vrefdir=$PWD/vservers/.vref
-vstubdir=$PWD/vservers/.vstub
-
-# XXX: The vserver reference name should be passed in as an argument
-# rather than being hardcoded.
-vrefname=default
+vref=${vrefdir}/${vrefname}
+# stubs are created in a subdir per slicefamily
+vstubdir=$PWD/vservers/.vstub/${vrefname}
 
 # Make /vservers and default vserver reference image
-vref=${vrefdir}/${vrefname}
 install -d -m 755 ${vref}
 
-# locate the packages and groups file
-pkgsfile=$(pl_locateDistroFile ../build/ ${pldistro} vserver.pkgs)
-
 # Some of the PlanetLab RPMs attempt to (re)start themselves in %post,
 # unless the installation is running inside the BootCD environment. We
 # would like to pretend that we are.
 export PL_BOOTCD=1
 
 # Populate image with vserver-reference packages
-pl_root_setup_chroot ${vref} -k -f $pkgsfile
+pl_root_makedevs ${vref}
+# locate the packages and groups file
+pkgsfile=$(pl_locateDistroFile ../build/ ${pldistro} vserver.pkgs)
+pl_root_mkfedora ${vref} ${pldistro} $pkgsfile
+pl_root_tune_image ${vref}
 
 systemvserver_count=$(ls ../build/config.${pldistro}/vserver-*.pkgs 2> /dev/null | wc -l)
 [ $systemvserver_count -gt 0 ] && for systemvserver in $(ls ../build/config.${pldistro}/vserver-*.pkgs) ; do
@@ -74,8 +73,8 @@ systemvserver_count=$(ls ../build/config.${pldistro}/vserver-*.pkgs 2> /dev/null
     echo "--------START BUILDING system vserver ${NAME}: $(date)"
 
     # "Parse" out the packages and groups for yum
-    systempackages=$(pl_getPackages ${pl_DISTRO_NAME} $systemvserver)
-    systemgroups=$(pl_getGroups ${pl_DISTRO_NAME} $systemvserver)
+    systempackages=$(pl_getPackages ${pl_DISTRO_NAME} $pldistro $systemvserver)
+    systemgroups=$(pl_getGroups ${pl_DISTRO_NAME} $pldistro $systemvserver)
 
     vdir=${vstubdir}/${NAME}
     rm -rf ${vdir}/*
@@ -103,7 +102,7 @@ systemvserver_count=$(ls ../build/config.${pldistro}/vserver-*.pkgs 2> /dev/null
     # step 1: clean out yum cache to reduce space requirements
     yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y clean all
 
-    [ -f ${vdir}/etc/yum.conf.rpmnew ] && mv ${vdir}/etc/yum.conf.rpmnew ${vdir}/etc/yum.conf
+    [ -f ${vdir}/etc/yum.conf.rpmnew ] && mv -f ${vdir}/etc/yum.conf.rpmnew ${vdir}/etc/yum.conf
 
     # step 2: figure out the new/changed files in ${vdir} vs. ${vref} and compute ${vdir}.changes
     rsync -anv ${vdir}/ ${vref}/ > ${vdir}.changes
@@ -128,7 +127,12 @@ systemvserver_count=$(ls ../build/config.${pldistro}/vserver-*.pkgs 2> /dev/null
     echo "--------DONE BUILDING system vserver ${NAME}: $(date)"
 done
 
+pkgsdir=$(dirname $pkgsfile)
+pkgsname=$(basename $pkgsfile .pkgs)
+postfile="${pkgsdir}/${pkgsname}.post"
+[ -f $postfile ] && /bin/bash $postfile ${vref} || :
+
 # switch the vserver reference /etc/yum.conf to the new one from the yum package
-[ -f ${vref}/etc/yum.conf.rpmnew ] && mv ${vref}/etc/yum.conf.rpmnew ${vref}/etc/yum.conf
+[ -f ${vref}/etc/yum.conf.rpmnew ] && mv -f ${vref}/etc/yum.conf.rpmnew ${vref}/etc/yum.conf
 
 exit 0